#include <gd.h>

void* prescale_image(char *bgfilename)
{
	// Create image pointer.
	gdImagePtr fgImage, bgImage;
	int dstX, dstY, destW, destH, srcW, srcH, fgHeight, fgWidth, pngMemSize = 3145728;
	char *retval, *test = malloc(10*sizeof(char));

	// Allocate 3 megs for the output image. There's GOT to be a better way to do this!
	void *output = malloc(pngMemSize);

	fgWidth=800;
	fgHeight=480;

	// background file pointer.
	FILE *bgFile;
	if(!(bgFile = fopen(bgfilename, "rb")))
	{ return (void*)strdup("FAILURE"); }

	// Read in the magic bytes and see if they are of any types we know...
	fread(test, 1, 9, bgFile);
	if(test[0] == (char)0xff && test[1] == (char)0xD8)
	{
		rewind(bgFile);
		bgImage = gdImageCreateFromJpeg(bgFile);
	}
	else if(test[0] == (char)0x89 && test[1] == (char)0x50 && test[2] == (char)0x4E && test[3] == (char)0x47 && test[4] == (char)0x0D && test[5] == (char)0x0A && test[6] == (char)0x1A && test[7] == (char)0x0A)
	{
		rewind(bgFile);
		bgImage = gdImageCreateFromPng(bgFile);
	}
	else if(test[0] == 'G' && test[1] == 'I' && test[2] == 'F')
	{
		rewind(bgFile);
		bgImage = gdImageCreateFromGif(bgFile);
	}
	else
	{ return strdup("FAILURE"); }

	free(test);
	fclose(bgFile);

	// Create color variables.
	int black;
	int white;

	// Make an image of a certain size.
	// TODO: query the framebuffer for this information.
	fgImage = gdImageCreateTrueColor(fgWidth, fgHeight);

	// copy the background onto our canvas
	dstX = 0;
	dstY = 0;
	destW = fgWidth;
	destH = fgHeight;
	srcW = bgImage->sx;
	srcH = bgImage->sy;

	if((float)((float)srcW/(float)fgWidth) > (float)((float)srcH/(float)fgHeight))
	{
		destW = fgWidth;
		destH = (int)((double)srcH/((float)srcW/(float)fgWidth));
		dstY = (int)((float)((float)fgHeight - (float)destH) / (float)2);
	}
	else
	{
		destH = fgHeight;
		destW = (int)((double)srcW/((float)srcH/(float)fgHeight));
		dstX = (int)((float)((float)fgWidth - (float)destW) / (float)2);
	}

	gdImageCopyResized(fgImage, bgImage, dstX, dstY, 0, 0, destW, destH, srcW, srcH);
	return fgImage;
}
